Index: trunk/SophyaPI/PI/pifilechogen.cc
===================================================================
--- trunk/SophyaPI/PI/pifilechogen.cc	(revision 2298)
+++ trunk/SophyaPI/PI/pifilechogen.cc	(revision 2300)
@@ -22,5 +22,5 @@
 //	contenant le nom complet du fichier. Si aucun fichier n'a été 
 //	sélectionné, le message de l'objet est completé avec "PIMsg_Cancel" et 
-//	le "datä contient le pointeur "NULL".
+//	le "data" contient le pointeur "NULL".
 //--
 //++
Index: trunk/SophyaPI/PI/pifontgen.cc
===================================================================
--- trunk/SophyaPI/PI/pifontgen.cc	(revision 2298)
+++ trunk/SophyaPI/PI/pifontgen.cc	(revision 2300)
@@ -46,5 +46,5 @@
 //	Constructeur de copie
 // PIFont & operator = (PIFont const & fnt) 
-//	Opérateur égal.
+//	Opérateur égal (affectation).
 // bool operator == (PIFont const & fnt) 
 //	Opérateur test d'égalité.
Index: trunk/SophyaPI/PI/pigraphgen.cc
===================================================================
--- trunk/SophyaPI/PI/pigraphgen.cc	(revision 2298)
+++ trunk/SophyaPI/PI/pigraphgen.cc	(revision 2300)
@@ -26,8 +26,17 @@
 //++
 // Links	Voir aussi
+// PIFont
+// PIColorMap
+//--
+//++
+// Links	et
 // PIGrCoord
 // PILineAtt
-// PIFont
-// PIColorMap
+//--
+//++
+// Links	Classes derivees
+// PIGraphicUC
+// PIGraphic3D
+// PIGraphicPS
 //--
 
@@ -132,8 +141,23 @@
 //	le tracé de texte.
 //	La chaine est trace avec une justification a gauche, ou droite,
-//	ou centree (horzontal) - bas, haut, milieu (vertical), en fonction de
+//	ou centree (horizontal) - bas, haut, milieu (vertical), en fonction de
 //	de la valeur du flag "pos"
 //|	PI_HorizontalLeft PI_HorizontalCenter PI_HorizontalRight
 //|	PI_VerticalBottom PI_VerticalCenter PI_VerticalTop
+// void  DrawCompString(PIGrCoord x, PIGrCoord y, const char* s, const char* s_up, \
+//       const char* s_dn, PIFont const & fntss, unsigned long pos = 0)
+//	Tracé d'une chaîne de caractères "s" avec une partie de texte en exposant "s_up"
+//	et une partie en indice "s_dn". Une fonte différente ("fntss") peut être 
+//	spécifiée pour la partie de texte en exposant et en indice. La taille 
+//	de la fonte exposant-indice est calculée automatiquement en fonction de 
+//	la taille de fonte courante. le positionnement s'effectue en fonction
+//	du flag "pos" :
+//|	PI_HorizontalLeft PI_HorizontalCenter PI_HorizontalRight
+//|	PI_VerticalBottom PI_VerticalCenter PI_VerticalTop
+// void  DrawCompString(PIGrCoord x, PIGrCoord y, const char* s, \
+//       const char* s_up, const char* s_dn, unsigned long pos = 0)
+//	Tracé d'une chaîne de caractères "s" avec une partie de texte en exposant "s_up"
+//	et une partie en indice "s_dn". Fonte exposant-indice identique à la fonte
+//	courante.
 //--
 
@@ -279,15 +303,13 @@
 //	Tracé d'un arc de cercle plein spécifié par trois points "(x1,y1)", "(x2,y2)" et "(x3,y3)"
 //--
-
-//++ 
-// Titre	Tracés de signes
-//--
-//++
-// void  DrawMarker(PIGrCoord x0, PIGrCoord y0)  
-//	Tracé d'un signe au point "(x0,y0)". Le choix du signe tracé s'effectue
-//	à travers la méthode "SelMarker()"
-// void  DrawMarkers(PIGrCoord *x, PIGrCoord *y, int n)
-//	Tracé de "n" signes aux points "(x[i],y[i])"
-//--
+//++
+// ComputeArcFrom3Pt(double x1, double y1, double x2, double y2, \
+//                   double x3, double y3, double& x0, double& y0, 
+//                   double& dx, double& dy, double& degdeb, double& deltadeg)
+//	Calcul des coordonnees du centre, du rayon, ainsi que l'extension
+//	angulaire d'un arc de cercle specifie par trois points. 
+//	*methode statique*
+//--
+
 
 /* --Methode-- */
@@ -319,12 +341,4 @@
 }
 
-//++
-// ComputeArcFrom3Pt(double x1, double y1, double x2, double y2, \
-//                   double x3, double y3, double& x0, double& y0, 
-//                   double& dx, double& dy, double& degdeb, double& deltadeg)
-//	Calcul des coordonnees du centre, du rayon, ainsi que l'extension
-//	angulaire d'un arc de cercle specifie par trois points. 
-//	*methode statique*
-//--
 /* --Methode-- */
 int PIGraphicGen::ComputeArcFrom3Pt(double x1, double y1, double x2, double y2,
@@ -455,4 +469,19 @@
   return(0);
 }
+
+//++ 
+// Titre	Tracés de signes et de flèches
+//--
+//++
+// void  DrawMarker(PIGrCoord x0, PIGrCoord y0)  
+//	Tracé d'un signe au point "(x0,y0)". Le choix du signe tracé s'effectue
+//	à travers la méthode "SelMarker()"
+// void  DrawMarkers(PIGrCoord *x, PIGrCoord *y, int n)
+//	Tracé de "n" signes aux points "(x[i],y[i])"
+// void DrawArrowMarker(PIGrCoord x1, PIGrCoord y1, PIGrCoord x2, PIGrCoord y2, \
+//      bool fgline=true)
+//	Tracé d'un signe de type flèche orienté selon la droite "x1,y1" -> "x2,y2".
+//	Si "fgline==true", la ligne "(x1,y1) (x2,y2)" est aussi tracée.
+//--
 
 /* --Methode-- */
@@ -597,5 +626,9 @@
 //|	PI_TriangleMarker , PI_FTriangleMarker
 //|	PI_StarMarker , PI_FStarMarker
-//	(Les "StarMaker" ne sont pas encore implémentés  11/98) 
+// void  SelArrowMarker(int arrsz=5, PIArrowMarker arrmrk=PI_BasicArrowMarker)
+//	Choix de la taille et du type de flèches.
+//|	PI_NotDefArrowMarker , PI_BasicArrowMarker
+//|	PI_TriangleArrowMarker , PI_FTriangleArrowMarker
+//|	PI_ArrowShapedArrowMarker , PI_FArrowShapedArrowMarker
 //--
 
@@ -663,4 +696,7 @@
 //	Renvoie la largeur occupé par un texte s'il était affiché dans le 
 //	système de coordonnées courant (Fenêtre ou UC).
+// bool  CalcStringPositionShift(char const* s, unsigned long pos, \
+//       int& dx, int& dy)
+//	Renvoie le shift de position compte tenu du flag de positionnement "pos"
 //--
 
Index: trunk/SophyaPI/PI/pilineatt.cc
===================================================================
--- trunk/SophyaPI/PI/pilineatt.cc	(revision 2298)
+++ trunk/SophyaPI/PI/pilineatt.cc	(revision 2300)
@@ -103,2 +103,55 @@
   }
 }
+
+//++
+// Titre	Opérateurs 
+//--
+
+//++
+// PILineAtt& operator = (PILineAtt const& b)
+//	Opérateur d'affectation à partir d'un PILineAtt.
+// PILineAtt& operator = (PILineTypes ltyp)
+//	Opérateur d'affectation à partir d'un PILineTypes.
+// bool operator == (PILineAtt const& b) const
+//	Opérateur test d'égalité avec un PILineAtt
+// bool operator == (PILineTypes ltyp)
+//	Opérateur test d'égalité avec un PILineTypes
+// bool operator != (PILineAtt const& b) const
+//	Opérateur test d'inégalité avec un PILineAtt
+// bool operator != (PILineTypes ltyp)
+//	Opérateur test d'inégalité avec un PILineTypes
+//--
+
+//++
+// Titre	Méthodes
+//--
+
+//++
+// int GetLineWidth() const
+//	Retourne l'épaisseur de ligne (en pixels).
+// int GetLineWidthx8() const
+//	Retourne l'épaisseur de ligne (en 1/8 pixels ou points).
+// double GetLineWidthD() const
+//	Retourne l'épaisseur de ligne (valeur flottante en pixels/points).
+// PILineDash GetLineDash()
+//	Retourne le type de ligne pointillé
+// PILineJoin GetLineJoin()
+//	Retourne le type de jointure de lignes
+// PILineCap  GetLineCap()
+//	Retourne le type de terminaison de lignes
+// void SetLineWidth(int lw)
+//	Définit l'épaisseur de ligne (en pixels/points).
+// void SetLineWidth(double lw)
+//	Définit l'épaisseur de ligne (valeur flottante en pixels/points).
+// void SetLineDash(PILineDash ld)
+//	Définit le type de ligne pointillé - enum PILineDash :
+//|	PI_LineSolid, PI_LineDashed
+//|	PI_LineDotted, PI_LineDashDotted
+//
+// void SetLineJoin(PILineJoin lj)
+//	Définit le type jointure de lignes - enum  PILineJoin :
+//|	PI_JoinMiter, PI_JoinRound, PI_JoinBevel
+// void SetLineCap(PILineCap lc) 
+//	Définit le type terminaison de lignes - enum  PILineCap :
+//|	PI_CapButt, PI_CapRound, PI_CapProjecting
+//--
Index: trunk/SophyaPI/PI/pitherm.cc
===================================================================
--- trunk/SophyaPI/PI/pitherm.cc	(revision 2298)
+++ trunk/SophyaPI/PI/pitherm.cc	(revision 2300)
@@ -11,5 +11,6 @@
 //
 //   	Classe permettant la visualisation d'une valeur sous forme 
-//   	d'une barre de progression
+//   	d'une barre de progression ou d'un thermomètre, avec trois 
+//	couleurs différentes, suivant deux valeurs de seuil.
 //--
 //++
@@ -22,5 +23,5 @@
 //--
 //++
-//  PIThermometer(PIContainerGen *par, char *nom, int sx=256, int sy=10, int px=0, int py=0);
+//  PIThermometer(PIContainerGen *par, char *nom, int sx=256, int sy=10, int px=0, int py=0)
 //	Constructeur - Le choix d'affichage (vertical ou horizontal) dépend
 //	du rapport des tailles "sx", "sy"
@@ -46,4 +47,23 @@
 }
 
+//++
+// Titre	Méthodes
+//--
+//++
+// long  kind()
+//	Retourne PIThermometer::ClassId .
+//--
+
+//++
+// void  SetMinMax(double min=0., double max=1.)
+//	Définit les valeurs minimum et maximum du thermomètre.
+// void  GetMinMax(double& min, double& max)
+//	Retourne les valeurs minimum et maximum du thermomètre.
+// void  SetValue(double val)
+//	Définit la valeur actuelle du thermomètre.
+// void  GetValue()
+//	Retourne la valeur actuelle du thermomètre.
+//--
+
 /* --Methode-- */
 void
@@ -55,5 +75,5 @@
 
 /* --Methode-- */
-void
+void 
 PIThermometer::GetMinMax(double& min, double& max)
 {
@@ -64,4 +84,5 @@
 void
 PIThermometer::SetValue(double val)
+//	Définit la valeur actuelle du thermomètre.
 {
   val_ = val;   
@@ -76,4 +97,16 @@
 }
 
+//++
+// void  SetThreshold(double t1=0.75, double t2=0.9)
+//	Définit les deux seuils pour les changements de couleurs.
+// void  GetThreshold(double& t1, double& t2)
+//	Retourne les deux seuils pour les changements de couleurs.
+// void  SetColors(PIColors c1=PI_Green, PIColors c2=PI_Yellow, PIColors c3=PI_Red)
+//	Définit les trois couleurs utilisées pour l'affichage.
+//|	Val : .... < Seuil1 <  ....  < Seuil2 <  ....
+//|	       c1               c2                c3
+//|     
+//--
+
 /* --Methode-- */
 void
@@ -83,4 +116,5 @@
 }
 
+/* --Methode-- */
 void
 PIThermometer::GetThreshold(double& t1, double& t2)
@@ -89,4 +123,6 @@
 }
 
+
+/* --Methode-- */
 void
 PIThermometer::SetColors(PIColors c1, PIColors c2, PIColors c3)
@@ -94,15 +130,10 @@
   lowc_ = c1;  medc_ = c2;  highc_ = c3;
 }
-
-//++
-// Titre	Méthodes
-//--
-//++
-// long  kind()
-//	Retourne PIThermometer::ClassId .
-//--
  
-
-/* --Methode-- */
+/* --Methode-- */
+//++
+// void  Draw(PIGraphicGen* g, int x0, int y0, int dx, int dy)
+//	Méthode effectuant l'affichage.
+//--
 void PIThermometer::Draw(PIGraphicGen* g, int /*x0*/, int /*y0*/, int /*dx*/, int /*dy*/)
 {